import processing.serial.*;

Serial myPort;  // The serial port 
int sensorValue;  // Value read from the sensor

void setup() { 
  // Set the window size 
  size(800, 600); 
  
  // List all the available serial ports 
  println(Serial.list()); 
  
  // Open the port you are using at the same speed as the Arduino 
  String portName = Serial.list()[0];  // Adjust based on your port 
  myPort = new Serial(this, portName, 9600); 
  
  // Set initial background color 
  background(255); 
} 

void draw() { 
  // Read the serial buffer 
  while (myPort.available() > 0) { 
    String inString = myPort.readStringUntil('\n'); 
    if (inString != null) { 
      inString = trim(inString); 
      sensorValue = int(inString); 
    } 
  } 
  
  // Map the sensor value to a vertical position for the graph 
  float y = map(sensorValue, 0, 1023, height, 0); 
  
  // Draw the graph 
  stroke(0);
  line(frameCount % width, height, frameCount % width, y); 
  
  // Clear the background periodically 
  if (frameCount % width == 0) { 
    background(255); 
  } 
} 
