import processing.serial.*;

Serial myPort;  // The serial port
int sensorValue;  // Value read from the sensor

void setup() {
  // Set the window size
  size(800, 600);
  
  // List all the available serial ports
  println(Serial.list());
  
  // Open the port you are using at the same speed as the Arduino
  String portName = Serial.list()[1];  // Replace with the correct index
  myPort = new Serial(this, portName, 9600);
  
  // Set initial background color
  background(255);
}

void draw() {
  // Read the serial buffer
  while (myPort.available() > 0) {
    String inString = myPort.readStringUntil('\n');
    if (inString != null) {
      inString = trim(inString);
      sensorValue = int(inString);
    }
  }
  
  // Clear the background
  background(255);
  
  // Map the sensor value to a vertical position for the graph
  float y = map(sensorValue, 0, 1023, height, 0);
  
  // Draw the graph
  stroke(0);
  line(width / 2, height, width / 2, y);
  
  // Draw the sensor value
  fill(0);
  textSize(32);
  text("Sensor Value: " + sensorValue, 10, height - 10);
}
